<?php
if ( ! defined( 'ABSPATH' ) ) { exit; }
if( ! class_exists('AWE_API')) {
    class AEW_API {
        function __construct(){
            
            $actionsPrivate = array(
                'aew_upload_product',
                'aew_update_product',
                'aew_get_categories',
                'aew_set_category_aliexpress',
                'aew_remove_category_aliexpress',
                'aew_get_save_order',
                'aew_get_debug_order',
                'aew_get_attributes',
                'aew_check_status_job',
                'aew_regenerate_token_cron',
                'aew_upload_category_job',
                'aew_delete_confirm_ids_products',
                'aew_disable_confirm_ids_products',
                'aew_active_confirm_ids_products',
                'aew_get_ids_category',
                'aew_remove_notices_job',
                'aew_remove_run_job',
                'aew_remove_id_product',
                'aew_set_token',
                'aew_get_catalog_ae',
            );
            foreach( $actionsPrivate as $action ){
                add_action( 'wp_ajax_'.$action, array( $this, $action ) );
                add_action( 'wp_ajax_nopriv_'.$action, array( $this, $action ) );

            }
        }
        function aew_delete_confirm_ids_products(){
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            require_once(AEW_AE_PATH . 'AEFactory.php');

            $factory = new AEFactory(AEW_TOKEN);
            $ids = $_POST['products'];
            $resultado_eliminar = json_decode($factory->wrapper->deleteProducts($ids), true);
            if(count($resultado_eliminar) == 0 or isset($resultado_eliminar['sub_msg'])) {
                foreach( $ids as $i ) {
                    $idWoo = AEW_MAIN::aew_get_product_by_idae($i);
                    delete_post_meta($idWoo['post_id'],'_aew_product_id');
                    update_post_meta($idWoo['post_id'],'_aew_status_ae', '0');
                    delete_post_meta($idWoo['post_id'],'_aew_product_sincro');
                }
            }
            error_log($resultado_eliminar);
            wp_send_json($resultado_eliminar);
            wp_die();


        }

        function aew_disable_confirm_ids_products(){
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            require_once(AEW_AE_PATH . 'AEFactory.php');

            $factory = new AEFactory(AEW_TOKEN);
            $ids = $_POST['products'];
            $resultado_eliminar = json_decode($factory->wrapper->disableProducts($ids), true);
            if(count($resultado_eliminar) == 0 or isset($resultado_eliminar['sub_msg'])) {
                foreach( $ids as $i ) {
                    $idWoo = AEW_MAIN::aew_get_product_by_idae($i);
                    update_post_meta($idWoo, '_aew_status_ae', '0');
                }
            }
            wp_send_json($resultado_eliminar);
            wp_die();


        }


        function aew_active_confirm_ids_products() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            require_once(AEW_AE_PATH . 'AEFactory.php');

            $factory = new AEFactory(AEW_TOKEN);
            $ids = $_POST['products'];
            $resultado_eliminar = json_decode($factory->wrapper->enableProducts($ids), true);
            if(count($resultado_eliminar) == 0 or isset($resultado_eliminar['sub_msg'])) {
                foreach( $ids as $i ) {
                    $idWoo = AEW_MAIN::aew_get_product_by_idae($i);
                    update_post_meta($idWoo, '_aew_status_ae', '1');
                }
            }
            wp_send_json($resultado_eliminar);
            wp_die();

        }

        static function get_variation_parent_ids_from_term( $term, $taxonomy, $type ){
            global $wpdb;
        
            return $wpdb->get_col( "
                SELECT DISTINCT p.ID
                FROM {$wpdb->prefix}posts as p
                INNER JOIN {$wpdb->prefix}posts as p2 ON p2.post_parent = p.ID
                INNER JOIN {$wpdb->prefix}term_relationships as tr ON p.ID = tr.object_id
                INNER JOIN {$wpdb->prefix}term_taxonomy as tt ON tr.term_taxonomy_id = tt.term_taxonomy_id
                INNER JOIN {$wpdb->prefix}terms as t ON tt.term_id = t.term_id
                WHERE p.post_type = 'product'
                AND p.post_status = 'publish'
                AND p2.post_status = 'publish'
                AND tt.taxonomy = '$taxonomy'
                AND t.$type = '$term'
            " );
        }

        function aew_get_ids_category() {
            if( !current_user_can( 'manage_options' ) ) { exit; }
            $cat = get_term_by('slug', sanitize_text_field($_POST['category']), 'product_cat', 'ARRAY_A');
            

            $argsProductos = array(
                'post_type' => array('product'),
                'fields' => 'ids',
                'suppress_filters' => true,
                'posts_per_page' => -1,
                'tax_query' => array(
                    array(
                        'taxonomy'      => 'product_cat',
                        'field'         => 'term_id',
                        'terms'         => $cat['term_id'],
                        'operator'      => 'IN'
                    ),
                ),
                'meta_query' => array(
                    array(
                        'key' => '_aew_product_id',
                        'compare' => '!=',
                        'value' => ''
                    )
                )
            );

            $variations = new WP_Query( array(
                'post_type'       => 'product_variation',
                'posts_per_page'  => -1,
                'fields' => 'ids',
                'post_parent__in' => self::get_variation_parent_ids_from_term( $cat['term_id'], 'product_cat', 'term_id' ), // Variations
                'meta_query' => array(
                    array(
                        'key' => '_aew_product_id',
                        'compare' => '!=',
                        'value' => ''
                    )
                )
            ) );
            $productos = get_posts($argsProductos);
            $productos = array_merge($productos, $variations->posts);
            $ids = [];
            foreach($productos as $val ) {
                $idSincro = get_post_meta($val, '_aew_product_id', true);
                    $ids[] = $idSincro;
            }

            wp_send_json($ids);
            wp_die();
        }

        function aew_remove_id_product() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            $idPost = sanitize_text_field( $_POST['post_id'] );

            delete_post_meta(intval($idPost), '_aew_product_id');
            delete_post_meta(intval($idPost), '_aew_need_upload');
            delete_post_meta(intval($idPost), '_aew_run_job');

            wp_send_json(array('true'));
            wp_die();
        }
        function aew_remove_notices_job() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            update_option('aew_notices_jobs', '');
        }
        function aew_upload_category_job() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            $cat = get_term_by('slug', sanitize_text_field($_POST['category']), 'product_cat', 'ARRAY_A');
            $categoriaLocal = intval($cat['term_id']);
            $configCategory = self::get_category_configuration('ND', $categoriaLocal);
            /**
             * Error with mapping category
             */
            if(isset($configCategory['error']) ) {
                return array('element_id' => intval($categoriaLocal), 'error' => true, 'msg' => $configCategory['msg']);
            }
            $unidadPeso = strtolower( get_option( 'woocommerce_weight_unit' ) );
            $argsProductos = array(
                'post_type' => 'product',
                'fields' => 'ids',
                'suppress_filters' => true,
                'posts_per_page' => -1,
                'tax_query' => array(
                    array(
                        'taxonomy'      => 'product_cat',
                        'field'         => 'term_id',
                        'terms'         => $categoriaLocal,
                        'operator'      => 'IN'
                    ),
                ),
                'meta_query' => array(
                    'relation' => 'OR',
                    array(
                        'key'     => '_aew_need_upload',
                        'value'   => '1',
                        'compare' => '='
                    ),
                    array(
                        'key' => '_aew_product_id',
                        'compare' => 'NOT EXISTS' // doesn't work
                    ),
                    array(
                        'key' => '_aew_product_id',
                        'value' => ''
                    )
                ));
                    $productos = get_posts($argsProductos);
                    
                    $productsToSend = array();
                    $productsToUpdate = array();
                    
                    foreach($productos as $p) {
                        $productAW = new AEW_Product();
                        $productoSend = $productAW->create($p, $configCategory['category'], $configCategory['attrsSelect'], $configCategory['featuresSelect'], $configCategory['typesFeatures'], $configCategory['fee_by_category'], $configCategory['categoriaLocal'], $configCategory['AtributosObligatorios'], $unidadPeso);
                        
                        if($productoSend) {
                            if(is_array($productoSend) && count($productoSend) > 1) {
                                foreach($productoSend as $variacion) {
                                    if($variacion->idAE != null) {
                                        $productsToUpdate[] = $variacion;
                                    }else{
                                        $productsToSend[] = $variacion;
                                    }
                                }
                            }else{
                                if($variacion->idAE != null) {
                                    $productsToUpdate[] = $productoSend;
                                }else{
                                    $productsToSend[] = $productoSend;
                                }
                            }
                        }
                    }

                    

            if(get_option("aew_checked_debug_mode") == "1") {
                $res = array(
                    'news' => $productsToSend,
                    'update' => $productsToUpdate
                );
                wp_send_json($res);
                die();
            }

            //Subir
            if(is_array($productsToSend) && count($productsToSend) > 0) {
                $job = AEW_Product::sendNew($configCategory['factory'], $configCategory['category'], $productsToSend);
                $obj_job = array(
                    'success_item_count' =>0, 
                    'total_item_count' =>count($productsToSend),
                    'job_id' =>$job,
                    'result_list' => ''
                );
                AEW_Job::create_job($obj_job);
                /**
                 * awe_run_job Updated with JOB id AE
                 * @since 1.0.4
                 */
                if(get_option("aew_checked_debug_mode") == "0") {
                    foreach($productsToSend as $proJob) {
                        update_post_meta(intval($proJob->id),'_aew_run_job', $job);
                    }
                }
            }


            //Actualizar
            if(is_array($productsToUpdate) && count($productsToUpdate) > 0) {
                $job = AEW_Product::sendUpdate($configCategory['factory'], $configCategory['category'], $productsToUpdate);
                $obj_job = array(
                    'success_item_count' =>0, 
                    'total_item_count' =>count($productsToUpdate),
                    'job_id' =>$job,
                    'result_list' => ''
                );
                AEW_Job::create_job($obj_job);
                /**
                 * awe_run_job Updated with JOB id AE
                 * @since 1.0.4
                 */
                if(get_option("aew_checked_debug_mode") == "0") {
                    foreach($productsToUpdate as $proJob) {
                        update_post_meta(intval($proJob->id),'_aew_run_job', $job);
                    }
                }
            }



            wp_send_json(array_merge($productsToSend, $productsToUpdate));
            wp_die();


        }
        function aew_regenerate_token_cron() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            $token = openssl_random_pseudo_bytes(16);
            $token = bin2hex($token);
            update_option('AEW_TOKEN_CRON', $token);
            wp_send_json(array('success' => true));
        }

        function aew_get_catalog_ae() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            require_once(AEW_AE_PATH . 'AEFactory.php');

            $factory = new AEFactory(AEW_TOKEN);

            $getAll = $factory->get_ae_products_list('publish');

            wp_send_json($getAll);
            wp_die();


        }
        /**
         * AEW_SET_TOKEN : Establece el Token para AliExpress
         *
         * @return void
         */
        function aew_set_token() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            if(!isset($_GET['aliexpress_token']) or !isset($_GET['expiration'])) { exit; }
            $token = sanitize_text_field($_GET['aliexpress_token']);
            $expiration = sanitize_text_field($_GET['expiration']);
            update_option('aew_token_auth', $token);
            update_option('aew_token_expiration', $expiration);
            wp_safe_redirect(admin_url('admin.php?page=aliexpress-general-options&auth=true'));
            exit();
            wp_die();
        }
        
        function aew_remove_run_job() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            $idProduct = intval(sanitize_text_field($_GET['id']));
            update_post_meta($idProduct,'_aew_run_job', '0');
            wp_safe_redirect( wp_get_referer() );
            wp_die();
        }
        /**
         * aew_upload_product - Envia el producto a AliExpress con los datos del producto desde WooCommerce
         *
         * @return array
         */
        private static function get_category_configuration($p, $categoriaLocal = false){
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            if(!$p) { die(''); }

            $p = intval($p);
            require_once(AEW_AE_PATH . 'AEFactory.php');
            require_once(AEW_AE_PATH . 'AEProduct.php');
            require_once(AEW_AE_PATH . 'AECategory.php');
            $res = array();
            
            if(!$categoriaLocal) {
                    $categorias = get_the_terms( $p, 'product_cat' );
                    
					$categoriasMapeadas = AEW_Category::show_categories_to_mapping(null, true);
					
					$available_cats = array();
					foreach($categoriasMapeadas as $cat) {
						$available_cats[] = $cat->term_id;
					}
					
					foreach($categorias as $cat) {
						if(in_array($cat->term_id, $available_cats)){
                            $res['categoriaLocal'] = $cat->term_id;
						}
					}
            }else{
                $res['categoriaLocal'] = $categoriaLocal;
            }
            
            $res['fee_by_category'] = floatval(get_term_meta(intval($res['categoriaLocal']),'aew_category_fee',true));
            
            $res['categoriaAliexpress'] = get_term_meta(intval($res['categoriaLocal']), 'aew_category_id', true);

            if(!$res['categoriaAliexpress']) {
                AEW_MAIN::register_error(__('Category Aliexpress is not declared', 'aliexpress'), 0, 'product');
                return array('element_id' => intval($res['categoriaLocal']), 'error' => true, 'msg' => __('An error ocurred with AliExpress category, see more information on log error.','aliexpress'));
            }
            
            $factory = new AEFactory(AEW_TOKEN);
            $res['factory'] = $factory;
            $res['category'] = $factory->get_category(intval($res['categoriaAliexpress']));
            // var_dump($res['categoriaLocal']);
            // die();
            $res['attrsSelect'] = AEW_Attributes::get_mapping_attr(intval($res['categoriaLocal']));
            $res['AtributosObligatorios'] = $factory->get_category_required_attributes(intval($res['categoriaAliexpress']));
            $res['featuresSelect'] = AEW_Features::get_mapping_features(intval($res['categoriaLocal']));

            
            $res['typesFeatures'] = $factory->get_category_attributes_types(intval($res['categoriaAliexpress']));
            
            return $res;


        }
        function aew_upload_product(){
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            $p = sanitize_text_field($_POST['id_p']);
            $unidadPeso = strtolower( get_option( 'woocommerce_weight_unit' ) );
            $productsToSend = array();
            if(is_array($_POST['id_p'])) {
                $configCategory = self::get_category_configuration($p[0]);
                
                foreach($_POST['id_p'] as $p) {
                    $productAW = new AEW_Product();
                    $productoSend = $productAW->create($p, $configCategory['category'], $configCategory['attrsSelect'], $configCategory['featuresSelect'], $configCategory['typesFeatures'], $configCategory['fee_by_category'], $configCategory['categoriaLocal'], $configCategory['AtributosObligatorios'], $unidadPeso);
                    $productsToSend = self::prepare_array_product($productsToSend, $productoSend);
                }
            }else{
                $configCategory = self::get_category_configuration($p);

                $productAW = new AEW_Product();
                $productoSend = $productAW->create($p, $configCategory['category'], $configCategory['attrsSelect'], $configCategory['featuresSelect'], $configCategory['typesFeatures'], $configCategory['fee_by_category'], $configCategory['categoriaLocal'], $configCategory['AtributosObligatorios'], $unidadPeso);
                
                //Prevent upload product null
                $productsToSend = self::prepare_array_product($productsToSend, $productoSend);
            }
            
            if(get_option("aew_checked_debug_mode") == "1") {
                wp_send_json($productsToSend);
                die();
            }
            if(is_array($productsToSend) && count($productsToSend) > 0) {
                $job = $productAW->sendNew($configCategory['factory'], $configCategory['category'], $productsToSend);
                if($job) {
                    $obj_job = array(
                        'success_item_count' => 0, 
                        'total_item_count' =>count($productsToSend),
                        'job_id' => $job,
                        'result_list' => ''
                    );
                    AEW_Job::create_job($obj_job);
                }else{
                    AEW_MAIN::register_error(__('Error Register JOB', 'aliexpress'), 0, 'product');
                    return;
                }

                /**
                 * awe_run_job Updated with JOB id AE
                 * @since 1.0.4
                 */
                if(get_option("aew_checked_debug_mode") == "0") {
                    foreach($productsToSend as $proJob) {
                        update_post_meta(intval($proJob->id),'_aew_run_job', $job);
                    }
                }

                wp_send_json(true);
                wp_die();
            }else{
                wp_send_json(false);
                wp_die();
            }
        
            
        }
        /**
         * Prepara el array para subir a AE
         *
         * @param array $productoSend
         * @return array
         */
        static function prepare_array_product($productsToSend, $productoSend) {
            if($productoSend) {
                if(is_array($productoSend) && count($productoSend) > 1) {
                    foreach($productoSend as $variation) {
                        array_push($productsToSend, $variation);
                    }
                }else{
                    $productsToSend[] = $productoSend;
                }
            }
            return $productsToSend;
        }
        /**
         * aew_update_product - Actualiza el producto a AliExpress con los datos del producto desde WooCommerce
         *
         * @return array
         */
        function aew_update_product(){
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            $p = sanitize_text_field($_POST['id_p']);
            $unidadPeso = strtolower( get_option( 'woocommerce_weight_unit' ) );
            $productsToSend = array();
            if(is_array($_POST['id_p'])) {
                $configCategory = self::get_category_configuration($p[0]);
                
                foreach($_POST['id_p'] as $p) {
                    $productAW = new AEW_Product();
                    $productoSend = $productAW->create($p, $configCategory['category'], $configCategory['attrsSelect'], $configCategory['featuresSelect'], $configCategory['typesFeatures'], $configCategory['fee_by_category'], $configCategory['categoriaLocal'], $configCategory['AtributosObligatorios'],$unidadPeso);
                    $productsToSend = self::prepare_array_product($productsToSend, $productoSend);
                }
            }else{
                $configCategory = self::get_category_configuration($p);
                
                $productAW = new AEW_Product();
                $productoSend = $productAW->create($p, $configCategory['category'], $configCategory['attrsSelect'], $configCategory['featuresSelect'], $configCategory['typesFeatures'], $configCategory['fee_by_category'], $configCategory['categoriaLocal'], $configCategory['AtributosObligatorios'], $unidadPeso);
                //Explosion de Variaciones
               $productsToSend = self::prepare_array_product($productsToSend, $productoSend);
            }
        
            if(get_option("aew_checked_debug_mode") == "1") {
                wp_send_json($productsToSend);
                die();
            }
            if(is_array($productsToSend) && count($productsToSend) > 0) {
                $job = $productAW->sendUpdate($configCategory['factory'], $configCategory['category'], $productsToSend);
                $obj_job = array(
                    'success_item_count' =>0, 
                    'total_item_count' =>count($productsToSend),
                    'job_id' =>$job,
                    'result_list' => ''
                );
                
                AEW_Job::create_job($obj_job);

                /**
                 * awe_run_job Updated with JOB id AE
                 * @since 1.0.4
                 */
                if(get_option("aew_checked_debug_mode") == "0") {
                    foreach($productsToSend as $proJob) {
                        update_post_meta(intval($proJob->id),'_aew_run_job', $job);
                    }
                }

                wp_send_json(true);
                wp_die();
            }else{
                wp_send_json(false);
                wp_die();
            }
        }


        function aew_check_status_job() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            if (function_exists('fastcgi_finish_request') AND $_SERVER['HTTP_USER_AGENT'] == 'api') {
                fastcgi_finish_request();
            }
            $idJob = intval($_POST['job']);
            if(empty($idJob)) { wp_send_json(array('error' => 'Out')); wp_die(); }
            require_once(AEW_AE_PATH . 'AEFactory.php');
            $factory = new AEFactory(AEW_TOKEN); 
            $job_state = $factory->batch_query_job($idJob);
            $job_state['last_check'] = date_i18n('d-m-Y H:i');
            $job_state = AEW_Job::get_status_job($job_state);
            AEW_Job::update_job($job_state);
            $job_state['update_products'] = AEW_Product::update_products_ids($job_state);
            wp_send_json($job_state);
            wp_die();
        }

        /**
         * aew_get_categories - Retorna las categorías de aliexpress, recibiendo el id de la categoria padre
         *
         * @return array
         */
        function aew_get_categories(){
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            if(!isset($_GET['id'])) {
                $c = 0;
            }else{
                $c = intval(sanitize_text_field($_GET['id']));
            }
            require_once(AEW_AE_PATH . 'AEFactory.php');
            
            $factory = new AEFactory(AEW_TOKEN); 
            $lang = substr(get_user_locale(), 0,2);
            $langs_available = array("en","ar","de","es","fr","in","it","iw","ja","ko","nl","pl","pt","ru","th","tr","vi");
            if(!in_array($lang, $langs_available)) {
                $lang = 'en';
            }
            $categorias = $factory->get_category_children($c, $lang);
            $res = array();
            $i = 0;
            foreach ($categorias as $item) {
                $res[$i]['id'] = $item['category_id']; //category_id
                $res[$i]['text'] = $item['category_name']; //category_name
                if(isset($_GET['id'])) {
                    $res[$i]['parent_id'] = $data['category_id'];
                }else{
                    $res[$i]['parent_id'] = 0;
                }
                if($item['is_leaf'] == '1' or $item['is_leaf'] == 1) {
                    $res[$i]['children'] = false;
                }else{
                    $res[$i]['state']['disabled'] = true;
                    $res[$i]['children'] = true;
                }
                $i++;
            }

            wp_send_json($res);
            wp_die();
        }
        function aew_get_attributes(){
            
        }
        function aew_set_category_aliexpress(){
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            $localCategory = sanitize_text_field($_POST['c_local']);
            $remoteCategory = sanitize_text_field($_POST['c_remote']);
            $nameCategory = sanitize_text_field($_POST['category_name']);

            $idCategoryRemote = update_term_meta(intval($localCategory), 'aew_category_id', $remoteCategory);
            $nameCategoryRemote = update_term_meta(intval($localCategory), 'aew_category_name', $nameCategory);
            $res = array(
                'error' => false,
                'success' => true
            );
            wp_send_json($res);
            wp_die();
        }
        function aew_remove_category_aliexpress(){
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            $localCategory = sanitize_text_field($_POST['c_local']);

            delete_term_meta(intval($localCategory), 'aew_category_id');
            delete_term_meta(intval($localCategory), 'aew_category_name');
        
            wp_send_json(true);
            wp_die();
        }

        function aew_get_save_order() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            $c = intval($_POST['idOrder']);
            

            $createOrder = AEW_Order::construct_order($c);

            wp_send_json($createOrder);
            wp_die();
        }
        function aew_get_debug_order() {
            if ( !current_user_can( 'manage_options' ) ) { exit; }
            $c = intval($_POST['idOrder']);
            

            $createOrder = AEW_Order::construct_order($c, true);

            wp_send_json($createOrder);
            wp_die();
        }
    }
}
$aliexpressAPI = new AEW_API();
?>