=== AliExpress for WooCommerce ===
Contributors: wecommsolutions
Tags: aliexpress, woocommerce, orders
Requires at least: 5.1
Tested up to: 5.8.2
Requires PHP: 5.6
Stable tag: 1.5.8

== Description ==

Official AliExpress Plugin for WooCommerce, publish any products you have in your WooCommerce store on AliExpress.

AliExpress is an online retailer based in China, owned by the Alibaba group, one of the best online markets in the world.

Located in USA, Russia, Spain, Italy, among others. It offers stores for companies and individuals to sell their products on its own platform.

**AliExpress WooCommerce is the official plugin for WooCommerce**. This plugin allows sellers to synchronize their product catalog, does not matter if they are simple or variable products. You will be able to sell your products easily with a single click, and synchronize AliExpress categories with your WooCommerce categories.

When receiving an order through AliExpress, this plugin will download this order into WooCommerce and you will be able to manage your shipment, assigning a tracking number to the order so that it is notified to AliExpress.

You previously must have a seller account on AliExpress, [click here to create an account](https://login.aliexpress.com/join/seller/unifiedJoin.htm?_regbizsource=ES_Woo_Wecomm)


[Online Documentation](https://wecomm.es/en/documentation)


# Characteristics

* Product Synchronization.
* AliExpress Categories Synchronization.
* Attribute Synchronization.
* Characteristics Synchronization.
* Order Synchronization.


# Product Functions

* Product Title
* Description
* SKU
* Stock
* Category
* Price
* Variations
* Characteristics
* Images
* Images of Variations
* Weight
* Dimensions

# Order Functions

Synchronize all orders automatically from AliExpress in your WooCommerce, manage the shipping process directly from WooCommerce, when shipping the product, mark the order as 'Finished' and enter the tracking number so that AliExpress notifies the customer.

# Categories

AliExpress WooCommerce allows you to synchronize AliExpress categories with the local WooCommerce categories, and easily set a percentage added to the total of product when sending to AliExpress. 
You will be able to set the default measurements and weight of the entire category, avoiding modifying the required parameters product by product.

# Attributes

The attributes allow to create variations of the products, different colors, etc... This is also synchronized with the product and with the AliExpress Attributes, also allows to select an alias to rename the attributes of AliExpress.

# Characteristics

Just as attributes are used to create variations in WooCommerce, they also allow you to define the product with its characteristics. For instance the finish or the material which the product is made. This is very important because AliExpress uses this data to position the product when the customer is looking for something concrete.

## Upgrade Notice ##

### 1.4.0 ###
Warning: Orders now use the default WooCommerce statuses
To COMPLETE an AliExpress order you must enter each order, since if you complete it from the order list (bulk action) the tracking number will NOT be sent to AliExpress and therefore the order will be canceled. Previous orders will not be shown in the WooCommerce panel, they will only have to modify their status if necessary.


== Changelog ==

= 1.5.8 =
* Enable / Disable products by bulk
* Min and Max range price to upload products AliExpress
* Minor Fixes

= 1.5.7 =
* Delete products by bulk
* Using explosion with general option for products variations.
* Set preparations days for each category
* Minor fixes

= 1.5.6 =
* Store manager Rol

= 1.5.5 =
* Fix PHP Errors
* Add support category and product description (replace, before or after)

= 1.5.4 =
* Option: Use ID by SKU

= 1.5.3 =
* Fix AliExpress Description style

= 1.5.1 =
* Add support to change default status order
* Minor fixes
* Apply hook content description category

= 1.5.0 =
* Add override description products by category.
* Change Support URL

= 1.4.8 =
* Fix form save order

= 1.4.7 =
* Register carrier for orders

= 1.4.6 =
* [FOR DEVELOPERS] Sent to AliExpress tracking number

= 1.4.5 =
* Set Tracker Order Fix

= 1.4.4 =
* Add support Order Debug

= 1.4.3 =
* Minor fixes

= 1.4.2 =
* Fix Order Empty Items

= 1.4.1 =
* Fix Items Orders.
* Fix Undeclared category for explosion products.
* Others Fix

= 1.4.0 =
* Warning: Orders now use the default WooCommerce statuses
To COMPLETE an AliExpress order you must enter each order, since if you complete it from the order list (bulk action) the tracking number will NOT be sent to AliExpress and therefore the order will be canceled.
* Fix Upload Category products
* Others minor fixs

= 1.3.2 =
* Fix Order List Pagination

= 1.3.1 =
* Add Support dev operations

= 1.3.0 =
* Variation explosion support
* Image products replace with medium size
* Minor Fixes


= 1.2.12 =
* Fix upload products when correlative variations
* Fix upload products with title is more than 128 characters
* Minor fixes

= 1.2.11 =
* Added support for Shipping Cost get from AliExpress
* Autoconvert weight product to kg when upload product to AliExpress
* Minor fixes

= 1.2.10 =

* Now all products uploaded to AliExpress without category default, is set the last category of product.
* Fix - Stock: When a order is downloaded from AliExpress, stock decresases, before version 1.2.10 this happened when the order was finalized.
* Do not allow change of status from the order table, orders can´t be completed batch

== Support ==

When your support license and upgrades are active you can request support for any problem the plugin may causes or doubt you may have.
Problems or doubts external to the plugin are not included. [click here for more information](https://wecomm.es/en/documentation)
